stages:
- build
- test

variables:
  IMAGE: registry.gitlab.com/unsl-up/$CI_PROJECT_NAME

build:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  script:
    - docker pull $IMAGE:latest || true
    - docker build --cache-from $IMAGE:latest --tag $IMAGE:$CI_BUILD_REF --tag $IMAGE:latest -f .gci/Dockerfile .
    - docker push $IMAGE:$CI_BUILD_REF
    - docker push $IMAGE:latest
  only:
    changes:
      - .gci/Dockerfile

ALU:
  stage: test
  image: $IMAGE:latest
  script:
    - bash .gci/run_test.sh ./test_python/ALU/

RegisterBank:
  stage: test
  image: $IMAGE:latest
  script:
    - bash .gci/run_test.sh ./test_python/RegisterBank/

ProgramCounter:
  stage: test
  image: $IMAGE:latest
  script:
    - bash .gci/run_test.sh ./test_python/ProgramCounter/

DataMem:
  stage: test
  image: $IMAGE:latest
  script:
    - bash .gci/run_test.sh ./test_python/DataMem/

ProgMem:
  stage: test
  image: $IMAGE:latest
  script:
    - bash .gci/run_test.sh ./test_python/ProgMem/
